<?php
abstract class Asg_Controller_Abstract_Generic
{
    protected $_view;
    protected $_viewScript;
    protected $_layoutScript;

    protected $_params = array();

    public final function __construct()
    {
        //Init view engine
        require_once(ASG_APPLICATION_PATH . '/views/' . 'Engine.php');
        $this->_view = new Asg_View_Engine($this->_getViewScriptPath());

        $this->init();
    }

    public function init()
    {
    }

    public function preDispatch(&$action)
    {
    }

    public function postDispatch($action)
    {
    }

    //
    // Accessors
    //

    public function getView()
    {
        return $this->_view;
    }

    public function getLayoutScript()
    {
        return $this->_layoutScript;
    }

    public function setViewScript($value)
    {
        $this->_viewScript = $value;
        return $this;
    }

    public function getViewScript()
    {
        return $this->_viewScript;
    }

    public function getParams()
    {
        return $this->_params;
    }

    public function getParam($key)
    {
        return isset($this->_params[$key])? $this->_params[$key] : NULL;
    }

    public function setParams(array $value)
    {
        $this->_params = $value;
    }

    //
    // Extensions
    //

    /**
    * Override to use custom path
    */
    protected function _getViewScriptPath()
    {
        return ASG_APPLICATION_PATH . '/views/scripts';
    }
}