<?php
require_once ASG_APPLICATION_PATH . '/controllers/Abstract/Metabox.php';

class Asg_Controller_MetaboxController
    extends Asg_Controller_Abstract_Metabox
{
    protected $_helpTitles = array(
        'product_details' => 'Product Details',
        'technical_details' => 'Technical Details',
    );

    public function indexAction()
    {
        global $post;

        $meta = Asg_Application::getModel('PostMeta')->setPostId($post->ID);

        $args = $this->getParams();
        $this->_view->type = $args[1]['args'][0];

        if (!$meta->getValue('item_id')) {
            $this->setViewScript('metabox/_not-native.phtml');
            return;
        }

        $this->_view->data = $meta->getValue($this->_view->type);
        $this->_view->helpTitles = $this->_helpTitles;
    }

    public function handleSavePostAction()
    {
        $this->setViewScript(NULL);

         // wp_insert_post() called while generate also use this handle
        if (!isset($_POST['asg_technical_details_save'])
           || !isset($_POST['asg_product_details_save'])
        ) {
            return;
        }

        $postId = $this->getParam(0);
        //$post = $this->getParam(1);

        Asg_Application::getModel('Details')->prepare($_POST)->save($postId);
    }

    public function extraContentAction()
    {
        global $post;

        $meta = Asg_Application::getModel('PostMeta')->setPostId($post->ID);

        if (!$meta->getValue('item_id')) {
            $this->setViewScript('metabox/_not-native.phtml');
            return;
        }
    }
}