<?php
require_once ASG_APPLICATION_PATH . '/models/AbstractModel.php';

class Asg_Model_Options extends Asg_Model_AbstractModel
{
    const PREFIX = Asg_WpPlugin::PREFIX;

    public function getValue($name, $default=NULL)
    {
        if (is_null($default)) {
            $default = Asg_Application::getConfig()->option_defaults->$name;
            if ($default instanceof AsgZend_Config) {
                $default = $default->toArray();
            }
        }

        return get_option(self::PREFIX . '_' . $name, $default);
    }

    public function setValue($name, $value)
    {
        return update_option(self::PREFIX . '_' . $name, $value);
    }

    public function unsetValue($name)
    {
        return delete_option(self::PREFIX . '_' . $name);
    }
}
