<?php
abstract class Asg_Service_Affiliate_ErrorHandler
{
    /**
     * Encapsulates set_error_handler()
     */
    public static function enable($errorTypes=E_ALL)
    {
        set_error_handler(array(get_class(), 'handleError'), $errorTypes);
    }

    /**
     * Encapsulates restore_error_handler()
     */
    public static function disable()
    {
        restore_error_handler();
    }

    /**
     * Handles PHP Errors
     */
    public static function handleError($errno, $errstr, $errfile, $errline,
        $errcontext)
    {
        if (0 == error_reporting()) {
            // @ operator
            return FALSE;
        }
        throw new ErrorException($errstr, 0, $errno, $errfile, $errline);

        return TRUE;
    }
}
