<?php
require_once ASG_APPLICATION_PATH . '/services/Affiliate/Plugin.php';

abstract class Asg_Service_Affiliate_Plugin_Adapter
    extends Asg_Service_Affiliate_Plugin
{
    protected $_publishedCount = 0;
    
    /**
    * Retrieves basic item info
    *
    * @param int $count Specifies approximate max merchant count
    * @param bool $preview Indicates search preview mode (do not delete published items)
    */
    abstract public function getItems($count, $preview=FALSE);

    public function getPublishedCount()
    {
        return $this->_publishedCount;
    }
    
    public function getCategories($parent = NULL)
    {
        return array();
    }

    // Adapter errors are fatal by default
    protected function throwError($message, $type='fatal')
    {
        return $this->getMainService()->throwError($message, $type);
    }
}