<?php
require_once ASG_APPLICATION_PATH . '/services/Affiliate/Plugin/Feedback.php';

class Asg_Service_Affiliate_Plugin_Feedback_Session 
    extends Asg_Service_Affiliate_Plugin_Feedback
{
    protected $_sessionNamespace = Asg_WpPlugin::PREFIX;
    
    public function exchange($message, $status=NULL, $progress=NULL)
    {
        @session_start();   
        
        $result = @$_SESSION[$this->_sessionNamespace]['command'];  
        
        if (is_null($message)) { 
            $_SESSION[$this->_sessionNamespace] = array(
                'log' => '',
                'status' => NULL,
                'command' => NULL,
            );
        } else {
            if (!isset($_SESSION[$this->_sessionNamespace])) {
                session_write_close();
                return 'terminate';   
            }    
        }
        
        if (!is_null($message) && '' != $message) {
            $_SESSION[$this->_sessionNamespace]['log'] .= $message;   
        }
         
        if (!is_null($status)) {
            $_SESSION[$this->_sessionNamespace]['status'] = $status; 
            if ($status != 'progress') {
                $_SESSION[$this->_sessionNamespace]['message'] = $message;    
            }       
        }  
        
        if (!is_null($progress)) {
            $_SESSION[$this->_sessionNamespace]['progress'] = $progress;     
        }  
           
        session_write_close();
        
        return $result;
    }
    
    public function terminate()
    {
        @session_start(); 
        unset($_SESSION[$this->_sessionNamespace]);
        session_write_close();       
    }   
}