<?php
require_once ASG_APPLICATION_PATH . '/services/AbstractService.php';

class Asg_Service_Setup extends Asg_Service_AbstractService
{
    public function install()
    {
        $options = Asg_Application::getModel('Options');

        $version = $options->getValue('version');
        if ('' == $version) {
            $options = Asg_Application::getModel('Options');

            // Rename market specific fields
            $marketCode = $options->getValue('amazon_market', NULL);
            if ('' != $marketCode) {
                $marketFields = array(
                    'affiliate_id'
                );
                foreach($marketFields as $field) {
                    $value =  $options->getValue($field, NULL);
                    if ('' != $value) {
                        $options->setValue("{$marketCode}_{$field}", $value);
                    }
                    $options->unsetValue($field);
                }
            }

            // Conver old price range
            $range = $options->getValue('price_range');
            if ('' != $range) {
                list($min, $max) = explode('-', $range, 2);
                if ('' != $min) {
                    $options->setValue('price_min', $min/100);
                }
                if ('' != $max) {
                    $options->setValue('price_max', $max/100);
                }
            }

            $options->unsetValue('price_range');

        } else {
            if ($version < '04.01.00') {
                $categories = array();
                $val = $options->getValue('search_category');
                if ('' != $val) {
                    $categories[] = $val;

                    $val = $options->getValue('search_subcategory');
                    if ('' != $val) {
                        $categories[] = $val;
                    }
                }

                $options->setValue('search_category', $categories);
            }

            if ($version < '04.02.00') {
                // Update customer reviews option
                $val = $options->getValue('show_reviews');
                if (!is_null($val)) {
                    $options->setValue('show_reviews_rev2', $val
                        ? 'embed'
                        : 'hide');
                }
                $options->unsetValue('show_reviews');
            }
        }

        $options->setValue('version', Asg_WpPlugin::VERSION);
    }
}