<?php

/*
Plugin Name: Associate Goliath
Plugin URI: http://associategoliath.com
Description: Associate Goliath Builds Amazon Affiliate Niche Blogs at The Push of a Button...
Author: George Katsoudas
Developer: A. Oliinyk (Pumka.net)
Version: 4.2.2
Author URI: http://www.georgekatsoudas.com
Tested up to: 3.8
*/

/**
* Version history:
* 4.2.2
*   fixed: wrong product unavailable state under certain conditions
* 4.2, 4.2.1
*   added: iframe option for customer reviews display
* 4.1.8
*   fixed RL1-BXR-2T7V: featured product rating was scraped when main product
*       had no rating
* 4.1.7
*   new tooltip text for "Cloak Affiliate Links" option
* 4.1.6
*   force usage of PluginUpdateChecker v1.3
* 4.1.5
*   new update logic for less server load
* 4.1.4
*   fixed: redirect issues
* 4.1.3
*   new update URL
* 4.1.2
*   fixed: compatibility issue with older WP versions
* 4.1.1
*   improved duplicate process prevention
* 4.1
*   added: dynamic Amazon category selection with unlimited hierarchy level
*   added: proptection from getting 400 error on Amazon API due to too many keywords entered
* 4.0.1
*   added: Show "View on Amazon" button option
* 4.0
*   added: add-to-cart button
* 3.0.1
*   minor fixes
* 3.0
*   added: GeoIP support
*   added: ability to select products from preview
*   added: optional affiliate link cloaking
* 2.5.6
*   ignore "0" server response
* 2.5.5
*   fixed: divizion by zero
* 2.5.4
*   fixed: product count limit still effective in ASIN mode
* 2.5.2
*   typo
* 2.5.1
*   fixed: star rating scraping didn't work for round numbers
* 2.5:
*   added: amazon.es support
* 2.4.3
*   fixed: missing JS libs for post/page editor
*   allow dots in associate IDs
*   metabox CSS fix
* 2.4.2
*   fixed BBG-7YG-WD7Y: isolate product not found error from API errors
* 2.4.1
*   fixed: first run issues
* 2.4
*   added: amazon.ca and amazon.de support
* 2.3.18
*   fixed GEV-PE5-4SNJ: better handling of Amazon API errors
* 2.3.17
*   added: skipping unavailable products
* 2.3.16
*   added: embedded auto-update system
* 2.3.15
*   added: workaround for Amazon request throttling
* 2.3.14
*   WordPress 3.5 compatibility
* 2.3.13
*   fixed 4W9-T1S-26WP: use application/json content type for AJAX responses
* 2.3.12
*   fixed 42B-5D8-DEYZ: do not allow whitespace in associate ID
* 2.3.11
*   better support for variation images
* 2.3.10
*   fixed M3H-3V2-SRQE: setDisabled jQuery plugin incorrectly detected jQuery
*       capabilities if two different jQuery versions loaded
* 2.3.9
*   fixed 6GN-Y7Y-NDHJ: SalePrice element wasn't supported
* 2.3.8
*   fixed HBA-XAW-WAMU: removed length limit for tracking ID
* 2.3.7
*   fixed 7H7-Y8X-QEEH: StringLength validator might fail with unusual
*       iconv encoding settings
* 2.3.6
*   fixed ST8-S86-R78D: session creation errors weren't always caught on plugin
* activation
* 2.3.5
*   fixed minor CSS and JS issues
* 2.3.4
*   added: ignore product descrition in API if less than 500 characters long
* 2.3.3
*   fixed: some products with variations were improperly reported as unavailable
* 2.3.2
*   fixed: call time pass-by-reference in amazon adapter
* 2.3.1
*   fixed: Amazon API error handling
* 2.3
*   added: additional virtual meta fields
* 2.2.3
*   fixed: PZU-1XY-RJM6 bug in Amazon API error handling
* 2.2.2
*   fixed: invalid p tags added by WP
* 2.2.1
*   fixed: wrong display of availability and prices for products with variations
* 2.2
*   added: interate through keywords if no result found for keyword combination
*   added: search by ASIN numbers option
* 2.1.14
*   fixed: wrong product rating display
* 2.1.13
*   fixed: interference of theme styles with button image styles
* 2.1.12
*   workaround for MySQL disconnections on some hosts
* 2.1.11
*   fixed: button text positioning wasn't working correct on some themes
* 2.1.10
*   added: virtual meta fields for AzonAdvice theme
* 2.1.9
*   fixed: wrong filter for tracking ID
* 2.1.8
*   added: require session initialization on plug-in activation
* 2.1.7
*   fixed: image not displayed for products having variants
* 2.1.6
*   better Amazon API error handling
*   workaround for servers with wrong clock
* 2.1.5
*   fixed: broken layout of eye candy on some themes
* 2.1.4
*   fixed: bug with cloacking plug-in
* 2.1.3
*   fixed: wrong "Currently unavailable" notice for some products
* 2.1.2
*   workaround for hostings with inlude_path folders restricted
* 2.1.1
*   fixed: potential crash with invalid Amazon credentials
* 2.1
*   added show reviews and minimum star rating options
* 2.0.1
*   fixed: wrong admin URLs on WPMU sites
*   fixed: preview stopping search on requested count even if published
* 2.0
*   added market selection and Amazon.co.uk market
*   added price range filter
*   added price timestamp
*   display stock inavailability
*   added admin options page
*   customer reviews scraping
*   added category selection widget with AJAX-powered new category add function
*   added publish all posts immediately option
*   added extra content shortcodes
*   added Product/Technical details editors
*   added Preview Results function
*   minor admin CSS tweaks
*   post template modifications
* 1.0.14:
*   fixed: bug with scraping product details containing a link to user manual
* 1.0.13
*   workaround for MySQL timout on HostGator
* 1.0.12
*   multiple product/technical details scraper enhacements
* 1.0.11
*   added: more info on HTTP request caused error
*   added: automatically refresh amazon_data if the meta field not found
*   added: refresh error message output in HTML comments
* 1.0.10
*   "add to cart" button on index pages
* 1.0.9
*   workaround for weird session problem
* 1.0.8
*   added: auto-update support
* 1.0.7
*   fixed: CSS issue with product/technical details on some themes
* 1.0.6:
*   fixed: distortion of non 160x160 images
* 1.0.5:
*   Multiple category configuration fixes
* 1.0.4:
*   fixed: few template issues
* 1.0.3:
*   added: WP and PHP version check on activation
*   fixed: keywords were still not scraped
* 1.0.2:
*   removed: non-working Watches category
*   fixed: Digital Music category setting
*   added: Amazon API message on no items found
*   allowed posts for products w/o description
*   fixed: template didn't show FREE item price
* 1.0.1:
*   added: Error handling for DB errors on post creation
**/

require_once dirname(__FILE__) . '/library/compatibility.php';

define('ASG_DEFAULT_CLOAK_DIR', 'recommends');

//Register plug-in:
Asg_WpPlugin::init();

class Asg_WpPlugin
{
//------------------------------------------------------------------------------
// Static members
//------------------------------------------------------------------------------
    const PLUGIN_BASE_URL = 'http://associategoliath.com/';
    const AUTHOR_BASE_URL = 'http://www.georgekatsoudas.com/';

    /**
    * Version tag. Used for CSS & JS versioning.
    */
    const VERSION = '04.02.02';

    /**
    * Unique slug
    */
    const SLUG = 'AssociateGoliath';

    /**
    * Product name for auto-update system
    */
    const PRODUCT_NAME = 'associate_goliath';

    /**
    * Unique prefix
    */
    const PREFIX = 'asg';

    /**
    * User-friendly title
    */
    const TITLE = 'Associate Goliath';

    /**
    * Menu item text
    */
    const MENU_LABEL = self::TITLE;

    /**
    * Required capability to access plug-in pages
    */
    const CAPABILITY = 'publish_posts';

    static protected $_instance;

    static protected $_pluginBaseUrl;
    static protected $_pluginPath;

    static protected $_postTemplateVars;

    static protected $_updater;
    static protected $_updaterCronHook;
    const UPDATE_CHECK_UNTERVAL = 12;

    /**
    * @var array Array of post meta field to read with their required status
    */
    static protected $_postMetaFields = array(
        'item_id' => TRUE,
        'amazon_data' => FALSE,
        'update_timestamp' => FALSE,
        'amazon_market' => FALSE,
        'last_refresh_attempt' => FALSE,
        'star_rating' => FALSE,
    );

    static protected $_amazonDataPostMetaFields = array(
        'azonwpthumb'   => 'image-url',
        'azonwpprice'   => 'price',
        'azonwplink'    => 'product-url',
    );

    static protected $_redirectPostMetaFields = array(
        /* 'azonwprating' => 'star_rating', */
    );

    /**
    * Parsed cloak URL
    */
    static protected $_redirectPath;

    /**
    * Registers plug-in module
    */
    static public function init()
    {
        // Auto update
        require dirname(__FILE__) . '/plugin-updates/plugin-update-checker.php';
        self::$_updater = new PluginUpdateChecker_1_3(
            'http://wppluginupdate.com/check/' . self::PRODUCT_NAME . '.json',
            __FILE__,
            self::PRODUCT_NAME,
            0
        );
        self::$_updaterCronHook = 'auto_check_updates-' . self::PRODUCT_NAME;
        add_action(self::$_updaterCronHook, array(self::$_updater, 'checkForUpdates'));

        self::$_pluginBaseUrl = trailingslashit(get_bloginfo('wpurl')) . PLUGINDIR
            . '/' . dirname(plugin_basename(__FILE__));

        self::$_pluginPath = dirname(__FILE__);

        $class = get_class();

        register_activation_hook(__FILE__, array($class, 'activate'));
        register_deactivation_hook(__FILE__, array($class, 'deactivate'));

        // Admin actions
        if (is_admin()) {
            add_action('admin_init', array($class, 'adminInit'));
            add_action('admin_init', array($class, 'autoCheckUpdates'));
            add_action('admin_menu', array($class, 'adminMenu'));
            add_action('wp_ajax_' . self::PREFIX, array($class, 'adminAjax'));
            add_action('admin_enqueue_scripts', array($class, 'adminEnqueueScripts'));
            add_action('save_post', array($class, 'savePost'), 10, 2);
        }

        // Frontend actions
        add_action('wp_print_styles',  array($class, 'wpPrintStyles'));

        add_action('wp_enqueue_scripts',  array($class, 'wpEnqueueScripts'));

        // Post filter actions
        add_action('loop_start', array($class, 'loopStart'));

        // Post metadata filter
        add_filter('get_post_metadata', array($class, 'getPostMetadata'), 10, 4);

        // Filter for calling post template from plug-ins
        add_action('cbc_exec_post_template', array($class, 'execPostTemplate'));

        // URL listener
        if (!is_admin() && self::checkUrl()) {
            add_filter('wp_loaded', array($class, 'filterUrl'));
        }

        self::addLibraryIncludePath();

        // Detect an update
        if (self::VERSION != get_option(self::PREFIX . '_version')) {
            self::loadApplication();
            Asg_Application::getService('Setup')->install();
        }
    }

    /**
    * Plug-in activate hook
    */
    static public function activate()
    {
        if (version_compare(PHP_VERSION, '5.0.0', '<')) {
            // Deactivate Plugin
            if(function_exists('deactivate_plugins')) {
                deactivate_plugins(plugin_basename(__FILE__), true);
            }

            // Display Error Message
            trigger_error(sprintf('Sorry, but Associate Goliath requires PHP 5.0 or newer. Your version is %s. Please, ask your web host to upgrade to PHP 5.0.', phpversion()), E_USER_ERROR);
        }

        // Requires Wordpress 3.0+
        global $wp_version;
        if (version_compare($wp_version, '3.0', '<' )) {
            // Deactivate Plugin
            if(function_exists('deactivate_plugins')) {
                deactivate_plugins(plugin_basename(__FILE__), true);
            }

            // Display Error Message
            trigger_error(sprintf('Sorry, but Associate Goliath requires Wordpress 3.0 or newer. Your version is %s. Please, upgrade to the latest version of Wordpress.', $wp_version), E_USER_ERROR);
        }

        if (!session_id()) {
            $oldErrorReporting = error_reporting();
            $oldDisplayErrors = ini_get('display_errors');
            $oldHtmlErrors = ini_get('html_errors');

            error_reporting(E_ALL);
            ini_set('display_errors', '1');
            ini_set('html_errors', '0');

            ob_start();
            $result = session_start();
            $error = ob_get_clean();

            error_reporting($oldErrorReporting);
            ini_set('display_errors', $oldDisplayErrors);
            ini_set('html_errors', $oldHtmlErrors);

            if (!$result || !session_id() || '' != $error) {
                // Deactivate Plugin
                if(function_exists('deactivate_plugins')) {
                    deactivate_plugins(plugin_basename(__FILE__), true);
                }

                $msg = 'Sorry but Associate Goliath requires PHP sessions. There was an error trying to start a session. Please, contact your hosting support in order to resolve the problem.';
                if ('' != $error) {
                    $msg .= ' The error message logged: ' . $error;
                }

                // Display Error Message
                trigger_error($msg, E_USER_ERROR);
            }
        }

        self::loadApplication();
        Asg_Application::getService('Setup')->install();
    }

    /**
    * Plug-in deactivation hook
    */
    static public function deactivate()
    {

    }

    static public function addLibraryIncludePath()
    {
        $includePaths = explode(PATH_SEPARATOR, get_include_path());
        $path = realpath(dirname(__FILE__) . '/library');
        if (!in_array($path, $includePaths)) {
            foreach ($includePaths as $key=>$item) {
                if ('.' == $item) {
                    unset($includePaths[$key]);
                    break;
                }
            }
            array_unshift($includePaths, $path);
            array_unshift($includePaths, '.');
            set_include_path(implode(PATH_SEPARATOR, $includePaths));
        }
    }

    static public function loadApplication()
    {
        self::addLibraryIncludePath();
        require_once(self::$_pluginPath . '/application/Application.php');
    }

    static public function checkUrl()
    {
        $path = explode('/', substr($_SERVER['REQUEST_URI'], strlen(self::getHomePath())));

        if ('index.php' == $path[0]) {
            array_shift($path);
        }

        if (count($path) < 2
            || self::getCloakDir() !== $path[0]
            || '' == $path[1]
        ) {
            return FALSE;
        }

        array_shift($path);

        self::$_redirectPath = $path;

        return TRUE;
    }

    static public function filterUrl()
    {
        self::loadApplication();

        $service = Asg_Application::getService('Linker')
            ->redirect(self::$_redirectPath);
    }

    static public function getCloakDir()
    {
        return get_option('asg_cloak_dir', ASG_DEFAULT_CLOAK_DIR);
    }

    static public function getHomePath()
    {
         return trailingslashit((string) parse_url(site_url(), PHP_URL_PATH));
    }

    static public function adminInit()
    {
         if (!session_id()) {
             // Workaround for weird problem (session_id not read from cookies)
             if (isset($_COOKIE[session_name()])) {
                 session_id($_COOKIE[session_name()]);
             }
             session_start();
         }
    }

    static public function autoCheckUpdates()
    {
        $updater = self::$_updater;
        $state = $updater->getUpdateState();

        $shouldCheck = (empty($state)
            || !isset($state->lastCheck)
            || ((time() - $state->lastCheck) >= (self::UPDATE_CHECK_UNTERVAL * 3600)))
            && !wp_next_scheduled(self::$_updaterCronHook);

        if ($shouldCheck) {
            wp_schedule_single_event(time(), self::$_updaterCronHook);
            spawn_cron();
        }
    }

    /**
    * admin_menu hook
    */
    static public function adminMenu()
    {
        self::getInstance()
            ->_registerAdminPages()
            ->_registerMetaBoxes();

    }

    static public function adminAjax()
    {
        self::getInstance()->dispatchAjax();
    }

    /**
    * wp_print_styles hook
    */
    static public function wpPrintStyles()
    {
        wp_enqueue_style(self::PREFIX . '/post.css',
            self::getInstance()->getPluginBaseUrl() . '/template/post.css',
            array(),
            date('YmdHis', filemtime(dirname(__FILE__) . '/template/post.css')));
    }

    static public function adminEnqueueScripts($hook)
    {
        $pageSlug = str_replace(' ', '-', strtolower(self::MENU_LABEL));

        switch ($hook) {
            case 'toplevel_page_' . self::SLUG:
                // Main page
                wp_enqueue_script(self::SLUG . '-admin-main',
                    self::getPluginBaseUrl() . '/js/admin-main.js',
                    array('jquery', 'jquery-ui-core', 'jquery-ui-dialog'),
                    self::VERSION);

                wp_enqueue_style(self::SLUG . '-admin',
                    self::getInstance()->getPluginBaseUrl() . '/css/admin.css',
                    array('wp-jquery-ui-dialog'),
                    self::VERSION);
                break;

            case $pageSlug . '_page_' . self::SLUG . '-options':
                // Options page
                wp_enqueue_script(self::SLUG . '-admin-options',
                    self::getPluginBaseUrl() . '/js/admin-options.js',
                    array('jquery'),
                    self::VERSION);

                wp_enqueue_style(self::SLUG . '-admin',
                    self::getInstance()->getPluginBaseUrl() . '/css/admin.css',
                    array(),
                    self::VERSION);
                break;

            case 'post.php':
            case 'post-new.php':
                wp_enqueue_style(self::SLUG . '-metabox',
                    self::getInstance()->getPluginBaseUrl() . '/css/metabox.css',
                    array(),
                    self::VERSION);
                wp_enqueue_script(self::SLUG . '-metabox',
                    self::getInstance()->getPluginBaseUrl() . '/js/metabox.js',
                    array('jquery', 'jquery-ui-core', 'jquery-ui-sortable', 'jquery-ui-draggable'),
                    self::VERSION);
                break;

            default:
                // Do not load common stuff fot other pages
                return;
        }

        // Common stuff
        wp_enqueue_style(self::PREFIX . '/help.css',
            self::getInstance()->getPluginBaseUrl() . '/css/help.css',
            array(),
            self::VERSION);
        wp_enqueue_script(self::PREFIX . '/help.js',
            self::getInstance()->getPluginBaseUrl() . '/js/help.js',
            array(),
            self::VERSION);
    }

    /**
    * wp_enqueue_scripts hook
    */
    static public function wpEnqueueScripts($hook)
    {
        wp_enqueue_script(self::PREFIX . '/post.js',
            self::getInstance()->getPluginBaseUrl() . '/js/post.js',
            array('jquery', 'jquery-ui-core'),
            self::VERSION);
    }

    static public function loopStart()
    {
        $class = get_class();

        add_filter('the_post', array($class, 'filterPost'));
        add_filter('the_content_more_link', array($class, 'filterContentMoreLink'));
        add_filter('the_content', array($class, 'filterContent'), -300);
    }

    static public function savePost($postId, $post)
    {
        // Ignore new posts, autosave and revisions:
        if (wp_is_post_autosave($postId)
            || wp_is_post_revision($postId)
            || 'auto-draft' == $post->post_status
            || 'trash' == $post->post_status
            || (isset($_POST['action']) && 'autosave' == $_POST['action'])
            || 'nav_menu_item' == $post->post_type
        ) {
            return;
        }

        self::getInstance()->dispatch__metabox__handle_save_post($postId, $post);
    }

    static public function filterPost($post)
    {
        self::$_postTemplateVars = NULL;

        if ('post' != $post->post_type) {
            return;
        }

        $postId = $post->ID;

        $vars = array();
        foreach (self::$_postMetaFields as $metaName => $required) {
            $val = get_post_meta($postId, self::PREFIX . '_' . $metaName, TRUE);
            if ('' == $val) {
                if ($required) {
                    return;
                } else {
                    $val = NULL;
                }
            }
            $vars[$metaName] = $val;
        }
        $vars['more_link'] = FALSE;
        $vars['post'] = $post;
        $vars['post_id'] = $postId;

        self::$_postTemplateVars = $vars;

        return;
    }

    static public function filterContentMoreLink($value)
    {
        if (self::$_postTemplateVars) {
            self::$_postTemplateVars['more_link'] = TRUE;
        }

        return $value;
    }

    static public function filterContent($value, $forceVars=NULL)
    {
        if (self::$_postTemplateVars) {
            self::$_postTemplateVars['content'] = $value;
            if ($forceVars) {
                self::$_postTemplateVars = array_merge(self::$_postTemplateVars, $forceVars);
            }
            ob_start();
            self::getInstance()->dispatch('template');
            $value = ob_get_clean();
        }

        return $value;
    }

    static public function execPostTemplate($post)
    {
        self::filterPost($post);
        $post->post_content = self::filterContent($post->post_content, array(
            'single' => TRUE,
        ));
    }

    static public function getPostMetadata($value, $objectId, $metaKey, $single)
    {
        if (isset(self::$_redirectPostMetaFields[$metaKey])) {
            return get_post_meta($objectId,
                self::PREFIX . '_' . self::$_redirectPostMetaFields[$metaKey], $single);
        }

        $action = NULL;

        if (isset(self::$_amazonDataPostMetaFields[$metaKey])) {
            $metaKey = self::$_amazonDataPostMetaFields[$metaKey];
        } else if ('amazon-' == substr($metaKey, 0, 7)) {
            $metaKey = substr($metaKey, 7);
        } else if ('amazon_data-' == substr($metaKey, 0, 12)) {
            $action = 'data';
        } else {
            return $value;
        }

        $data = get_post_meta($objectId, self::PREFIX . '_amazon_data', TRUE);
        if (!is_array($data)) {
            return $value;
        }

        $result = self::dispatch('amazon-data', $action, array(
            'meta_key'  => $metaKey,
            'data'      => $data,
            'object_id' => $objectId,
        ));

        if (!is_null($result)) {
            if ((!$single && !is_array($result))
                || $single && is_array($result)
            ) {
                $result = array($result);
            }
            $value = $result;
        }

        return $value;
    }

    /**
    * Returns array of available post types
    */
    static protected function getPostTypes()
    {
        return function_exists('get_post_types')
            ? get_post_types('','names')
            : array('post', 'page');
    }

    static public function getPostTemplateVars()
    {
        return self::$_postTemplateVars;
    }

    /**
    * Singleton pattern
    *
    * @return Asg_WpPlugin Singleton instance
    */
    static public function getInstance()
    {
        if (!self::$_instance) {
            self::$_instance = new self;
        }

        return self::$_instance;
    }

    static public function getPluginBaseUrl()
    {
        return self::$_pluginBaseUrl;
    }

    static public function getPluginPath()
    {
        return self::$_pluginPath;
    }

//------------------------------------------------------------------------------
// Object members
//------------------------------------------------------------------------------

    /**
    * Register plug-in admin pages and menus
    */
    protected function _registerAdminPages()
    {
        add_menu_page(self::TITLE, self::MENU_LABEL,
            self::CAPABILITY, self::SLUG,
            array($this, 'dispatchAdmin'),
            self::getPluginBaseUrl() . '/images/icon.png'
        );

        add_submenu_page(self::SLUG, self::TITLE,
            'Admin', self::CAPABILITY,
            self::SLUG,
            array($this, 'dispatchAdmin')
        );
        add_submenu_page(self::SLUG, self::TITLE,
            'Options', self::CAPABILITY,
            self::SLUG . '-options',
            array($this, 'dispatch__admin__options')
        );

        return $this;
    }

    /**
    * Register plug-in admin metaboxes
    */
    protected function _registerMetaBoxes()
    {
        add_meta_box(self::PREFIX . '_extra_content',
            'Add Extra Content in Associate Goliath Post', //self::TITLE,
            array($this, 'dispatch__metabox__extra_content'),
            'post', 'normal', 'high');
        add_meta_box(self::PREFIX . '_technical_editor',
            'Technical Details - Used for Associate Goliath posts', //self::TITLE,
            array($this, 'dispatch__metabox__index'),
            'post', 'normal', 'high', array('technical_details'));
        add_meta_box(self::PREFIX . '_product_editor',
            'Product Details - Used for Associate Goliath posts', //self::TITLE,
            array($this, 'dispatch__metabox__index'),
            'post', 'normal', 'high', array('product_details'));

        return $this;
    }

    /**
    * Intercepts WP requests
    */
    public function __call($method, $arguments)
    {
        if ('dispatch__' == substr($method, 0, 10)) {
            $parts = explode('__', $method);
            $controller = @$parts[1];
            $action = @$parts[2];

            $controller = $this->_prepareMvcName($controller);
            $action = $this->_prepareMvcName($action);

            $this->dispatch($controller, $action, $arguments);
        }
        else {
            throw new Exception("Method {$method} not found.");
        }
    }

    protected function _prepareMvcName($name)
    {
        return str_replace('_', '-', $name);
    }

    /**
    * Dispatches user request to WP Module
    *
    * @param string $controller Controller name
    * @param string $action Action name
    */
    public function dispatch($controller='index', $action='index',
        $params = NULL)
    {
        self::loadApplication();
        return Asg_Application::dispatch($controller, $action, $params);
    }

    public function dispatchAdmin()
    {
        $controller = @$_GET['controller'];
        if (empty($controller)) {
            $controller = 'admin';
        }
        $action = @$_GET['action'];
        if (empty($action)) {
            $action = 'index';
        }

        $this->dispatch($controller, $action);
    }

    public function dispatchAjax()
    {
        $controller = @$_POST['controller'];
        if (empty($controller)) {
            $controller = 'index';
        }
        $action = @$_POST['controller_action'];
        if (empty($action)) {
            $action = 'index';
        }

        $this->dispatch($controller, $action);

        exit();
    }
}