/**
* Associate Goliath main admin page JS script
*/

"use strict";

jQuery(function($) {
    $.fn.resetCategorySelect = function() {
        this.empty().append('<option value="0">(any)</option>');

        return this;
    };

    $.fn.setDisabled = function(value) {
        if (typeof this['prop'] === 'function') {
            this.prop('disabled', value);
        } else if (value) {
            this.attr('disabled', 'disabled');
        } else {
            this.removeAttr('disabled');
        }

        if (value) {
            this.addClass('disabled');
        } else {
            this.removeClass('disabled');
        }

        return this;
    };

    // Init

    $("#asg-affiliate_id-dialog").dialog({
        autoOpen: false,
        dialogClass: 'wp-dialog asg-dialog',
        modal: true,
        buttons: [{text: "OK", click: function(){ $(this).dialog('close'); }}],
        draggable: false,
        resizable: false,
        title: 'Amazon Associate IDs (<a href="#" class="asg-help-link" data-identifier="affiliate_id-dialog">help</a>)'
    });
    $("#asg-affiliate_id-button").click(function() {
        $("#asg-affiliate_id-dialog").dialog('open');
    });

    // Scheduling options

    $('#publish_type-schedule').click(function() {
        $('#posts_per_week').setDisabled(false);
    });

    $('#publish_type-immediately').click(function() {
         $('#posts_per_week').setDisabled(true);
    });

    // Product search

    $('#keywords_type_asin').click(function() {
        $('#max_items, #price_min, #price_max, .asg-search_category, #preview-button').setDisabled(true);;
        //$('').setDisabled(true);
    });

    $('#keywords_type_keyword').click(function() {
        $('#max_items, #price_min, #price_max, .asg-search_category, #preview-button').setDisabled(false);
    });

    // Schedule posts under this category

    $("#category-add-toggle").click(function(){
          $(this).parents("div:first").toggleClass("wp-hidden-children");

          $("#newcat").focus();
          return false;
    });

    $('#newcat').keypress(function() {
        if (13 == event.which) {
            event.preventDefault();
             $('#category-add-submit').click();
        }
    })

    // Actions

    $('.action-button').click(function() {
        $('#action').val($(this).attr('data-action'));
    });

    $('#category-add-submit').click(function() {
        var $this = $(this);

        $('#category_add-ajax-response').hide();

        var newCat = $.trim($('#newcat').val());
        var parent = $('#newcat_parent').val();

        if ('' == newCat) {
            $('#category_add-ajax-response span').text('Please enter a category name');
            $('#category_add-ajax-response').show();
            $("#newcat").focus();

            return false;
        }

        $('#asg_ajax_loading-category_add').css('visibility', 'visible');
        $this.setDisabled(true);

        var data = {};
        data['action'] = 'asg';
        data['controller'] = 'admin';
        data['controller_action'] = 'ajax-add-category';
        data['parent'] = parent;
        data['newCat'] = newCat;

        $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: data,
            dataType: 'json',
            success: function(data) {
                if ('' != data['error']) {
                    $('#category_add-ajax-response span').text('Error adding a category: ' + data['error']);
                    $('#category_add-ajax-response').show();
                } else {
                    var newCat = data['result']['label'];
                    var newCatSort = newCat.toLowerCase();
                    var prevLabel = '';
                    var curLabel = '';
                    var inserted = false;
                    var newId = data['result']['id'];
                    var newLi = $('<li id="category-' + newId + '" />')
                        .append($('<label class="selectit" />').text(' ' + newCat)
                            .prepend('<input value="' + newId + '" checked="checked" type="checkbox" name="post_category[]" id="in-category-' + newId + '">'));
                    var parentElement = parent > 0
                        ? $('#category-' + parent)
                        : $('#category-all');

                    if (parentElement.children('ul').length == 0) { // add ul, if not present
                        parentElement.append($(parent > 0? '<ul class="children" />' : '<ul id="categorychecklist" class="list:category categorychecklist form-no-clear" />')
                            .append(newLi));
                    } else { // cycle through items and compare cat name with existing cat names
                        $('ul', parentElement).first().children('li').each(function(n, elem) {
                              curLabel = $.trim($(elem).children('label:first').text()).toLowerCase();
                            if (newCatSort >= prevLabel && newCatSort < curLabel){
                                  $(elem).before(newLi); // add li before
                                  inserted = true;
                               return false;
                               }
                               prevLabel = curLabel;
                        });
                        if (!inserted) { // if no room to inserted, append to the end of the list
                            $('ul', parentElement).first().append(newLi);
                        }
                    }

                    var label = '';
                    var id = 0;
                    var level = 0;
                    $('#newcat_parent').empty();
                    $('#newcat_parent').append('<option value="-1">(parent category)</option>');
                    $('#categorychecklist').find('li').each(function(n, elem){
                        label = $.trim($(elem).children('label:first').text());
                        id = $(elem).children('label').children('input:first').val();
                        level = $(elem).parents('ul.children').length;
                        var pref = '';
                        for(var i = 0; i < level; i++) {
                            pref = pref + '&nbsp;&nbsp;&nbsp;';
                        }
                        $('#newcat_parent').append('<option class="level-' + level + '" value="' + id + '">' + pref + label + '</option>');

                    });

                    $('#in-category-' + newId).focus()

                    $("#newcat").val('');
                }
            },
            error: function() {
                $('#category_add-ajax-response span').text('Connection error: ' + data['error']);
                $('#category_add-ajax-response').show();
            },
            complete: function() {
                $('#asg_ajax_loading-category_add').css('visibility', 'hidden');
                $this.setDisabled(false);
            }
        });
    });

    $('#asg_form-admin').submit(function() {
        $(this).find('input[type="submit"], button[type="submit"]').setDisabled(true);
        $('#dialog_data').val($('.asg-dialog-content input, .asg-dialog-content select, .asg-dialog-content textarea').serialize());
    });

    $('#select_items-all').click(function() {
        var value = 'checked' == $(this).attr('checked');
        $('.select_items').attr('checked', value? 'checked' : null);
        $(this).attr('title', value? 'Clear selection' : 'Select all');
    });

    $('.asg-credential').change(function() {
        if (0 == $('#asg-search_category-container .asg-search_category').length
            && '' != $.trim($(this).val())
        ) {
            searchCategoryAjaxRequest(-1);
        }
    });

    var searchCategoryAjaxXhr = null;
    var noSubcategoriesHideTimeout = null;

    function searchCategoryAjaxRequest(index)
    {
        if (null == index) {
            var elem = $('#asg-search_category-container .asg-search_category').last();
            index = elem.length? elem.attr('data-index'): '-1';
        }

        index = parseInt(index);

        if (searchCategoryAjaxXhr) {
            searchCategoryAjaxXhr.abort();
            searchCategoryAjaxXhr = null;
        }

        if (noSubcategoriesHideTimeout) {
            clearTimeout(noSubcategoriesHideTimeout);
            noSubcategoriesHideTimeout = null;
        }

        $('#asg-search_category-error_notice').hide();
        $('#asg-search_category-no_subcategories_notice').hide();

        // Remove affected selects and get parent value
        var parent = null;
        $('#asg-search_category-container .asg-search_category').each(function() {
            var $this = $(this);
            var currentIndex = parseInt($this.attr('data-index'));
            if (currentIndex > index) {
                $this.remove();
            } else if (currentIndex == index) {
                parent = $this.val();
            }
        });

        if (index >= 0 && '0' == parent) {
            // if "(any)" category selected just exit
            return;
        }

        var data = {};
        var hasCredentials = true;
        $.each(asg_credentials, function(i, field) {
            var value = $('#' + field).val();
            if ('' == value) {
                $('asg-search_category-credential_notice').show();
                hasCredentials = false;
                return false;
            }
            data[field] = value;
        });

        if (!hasCredentials) {
            return;
        }

        $('#asg-search_category-credential_notice').hide();
        $('#asg-search_category-ajax_loader').show();

        data['action'] = 'asg';
        data['controller'] = 'admin';
        data['controller_action'] = 'ajax-get-categories';
        data['parent'] = parent;

        searchCategoryAjaxXhr = $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: data,
            dataType: 'json',
            index: index,
            success: function(data) {
                if ('' == data.error) {
                    if ('undefined' != typeof(data.result.categories)) {
                        var newIndex = this.index + 1; // New element index, this holds index passed to searchCategoryAjaxRequest
                        var elem = $('\
                            <select id="search_category_' + newIndex + '" \
                                name="search_category[' + newIndex + ']" \
                                class="asg-search_category asg-field-full_width" \
                                data-index="' + newIndex + '" \
                            > \
                            <option value="0" selected="selected">(any)</option> \
                            </select>');

                        $.each(data.result.categories, function(i, item) {
                            elem.append($('<option/>', {
                                value: item['id'],
                                text: item['label']
                            }));
                        });
                        if (!$('#keywords_type_keyword').attr('checked')) {
                            elem.setDisabled(true);
                        }

                        elem.change(function() {
                            searchCategoryAjaxRequest($(this).attr('data-index'));
                        });

                        $('#asg-search_category-container').append(elem);
                    } else {
                        // No subcategories
                        $('#asg-search_category-no_subcategories_notice').show();
                        noSubcategoriesHideTimeout = setInterval(function() {jQuery('#asg-search_category-no_subcategories_notice').slideUp();}, 10000)
                    }
                } else {
                    var errorElem = $('#asg-search_category-error_notice');
                    errorElem.find('.error').text(data['error'] + '.');
                    errorElem.show();
                }

            },
            error: function(xhr, ajaxOptions, thrownError) {
                var errorElem = $('#asg-search_category-error_notice');
                errorElem.find('.error')
                    .text('AJAX request failed.');
                errorElem.show();
            },
            complete: function() {
                searchCategoryAjaxXhr = null;
                $('#asg-search_category-ajax_loader').hide();
            }
        });
    }

    $('#asg-search_category-container .asg-search_category').change(function() {
        searchCategoryAjaxRequest($(this).attr('data-index'));
    });

    $('#asg-search_category-retry').click(function() {
        searchCategoryAjaxRequest(null);
        return false;
    });

    /**
    * Market change
    */
    $('#amazon_market').change(function() {
        var market = $('#amazon_market').val();
        if ('undefined' != typeof(asg_marketInfo[market])) {
            $(".asg_price_symbol")
                .html(asg_marketInfo[market]['currencySymbol']);
        }

        // affiliate_id dialog

        $('#asg-affiliate_id-dialog .asg-form-field').each(function() {
            $(this).toggle(market != $(this).attr('data-market'));
        });

        var elem = $('#asg_form-admin .affiliate_id-container .asg-input');
        if (elem.length) {
            $('#asg-affiliate_id-dialog .' + elem.attr('data-market') + '_affiliate_id-container')
                .append(elem);
        }

        elem = $('#asg-affiliate_id-dialog .' + market + '_affiliate_id');
        $('#asg_form-admin .affiliate_id-container').append(elem);
        $('#asg_form-admin .affiliate_id-label').attr('for', elem.attr('id'));

        searchCategoryAjaxRequest(-1);
    });
});