jQuery(function($) {
	var sortableOptions = {
        placeholder: 'ui-state-highlight',
        opacity: 0.6
    };

    asg_getMetabox = function(elem){
        return $(elem).parents('div.asg_details_container');
    };

    asg_changeAllCheckbox = function(elem){
        $(elem).find('input:checkbox:not(.asg_change_all)')
            .attr('checked',
                'checked' == $(elem).find('input.asg_change_all').attr('checked')
            );
    };

    asg_addItem = function(elem) {
        var name = $(elem).attr('id');
        $(elem).find('.asg_details_noitems').hide();
        $(elem).find('.asg_details_toggle').show();
        $(elem).find('ul.asg_details_list')
            .sortable('destroy')
            .append($('<li class="asg_sortable" />'))
            .sortable(sortableOptions)
            .children('li:last-child')
            .append($('<input type="checkbox" name="' + name + '[id][]" />'))
            .append($('<span />').css('margin-left', '3px')
                .append($('<input type="text" class="asg_details_key" name="' + name + '[key][]" />'))
                .append($('<textarea class="asg_details_val" rows="3" name="' + name + '[val][]" />')
                    .css('margin-left', '4px')))
            .find('textarea').focus();
    };

    asg_deleteItem = function(elem) {
        var list = $(elem).find('ul.asg_details_list');
        list.sortable('destroy');
        $(elem).find('input:checkbox:checked:not(.asg_change_all)').parent().remove();
        list.sortable(sortableOptions);
        if (0 == list.children('li').length) {
            $(elem).find('.asg_details_noitems').show();
            $(elem).find('.asg_details_toggle').hide();
            $('.asg_change_all').attr('checked', false);
        }
    };

      // set sortable
    $('.asg_details_list').sortable(sortableOptions);

      // checkbox
    $('.asg_details_container input.asg_change_all').change(function(){
        asg_changeAllCheckbox(asg_getMetabox(this));
    });

      // add li
    $('.asg_details_container input.asg_details_item_add').click(function(){
        asg_addItem(asg_getMetabox(this));
    });

      // delete li
    $('.asg_details_container input.asg_details_item_delete').click(function(){
        asg_deleteItem(asg_getMetabox(this));
    });

});