<?php
$marketInfo = Asg_Application::getConfig()->amazon->marketInfo->toArray();
?>
<?php echo $this->partial('includes/shortcode.phtml', array('code' => 'ag-top', 'content' => $this->shortcodes['ag-top'])); ?>
<?php require 'includes/candyTop.phtml'; ?>
<?php if($this->single): ?>
    <?php echo $this->partial('includes/shortcode.phtml', array('code' => 'ag-before-rating', 'content' => $this->shortcodes['ag-before-rating'])); ?>
    <?php $this->getHelper('StripNewLines')->start(); ?>
    <?php $star = $this->star_rating; ?>
    <?php if (!is_null($star)): ?>
        <div class="asg_star_rating-container">
            <span>Rating:&nbsp;</span>
            <span class="asg_star_rating asg_star_rating-<?php echo $this->starRatingCode($star); ?>"
                title="<?php echo sprintf('%01.1f', $star); ?> out of 5 stars">
            </span>
        </div>
    <?php endif; ?>
    <?php echo $this->partial('includes/shortcode.phtml', array('code' => 'ag-before-price', 'content' => $this->shortcodes['ag-before-price'])); ?>
    <div class="asg_price_container">
        <?php if (!isset($this->price['offer'])): ?>
            <span>Amazon Price:</span>
            <span class="asg_price_value"><?php echo $this->escape($this->price['listPrice']); ?></span>
            <span class="asg_price_notice">(as of <?php echo $this->price['date']; ?> -
                <?php require 'includes/priceNotice.phtml';  ?>
            </span>
        <?php else: ?>
             <span>Amazon Price:</span>
             <span class="asg_price_list_value"><?php echo $this->escape($this->price['listPrice']); ?></span>
             <span class="asg_price_offer_value">
                 <?php if (isset($this->price['offer']['SalePrice']['FormattedPrice'])): ?>
                     <?php echo $this->escape($this->price['offer']['SalePrice']['FormattedPrice']); ?>
                 <?php else: ?>
                     <?php echo $this->escape($this->price['offer']['Price']['FormattedPrice']); ?>
                 <?php endif; ?>
             </span>
             <?php if (isset($this->price['offer']['AmountSaved'])): ?>
                 <span>You save:</span>
                 <span class="asg_price_save_value">
                     <?php echo $this->escape($this->price['offer']['AmountSaved']['FormattedPrice']); ?>
                     (<?php echo $this->escape($this->price['offer']['PercentageSaved']);?>%).
                 </span>
             <?php endif; ?>
             <span class="asg_price_notice">(as of <?php echo $this->price['date']; ?> -
                 <?php require 'includes/priceNotice.phtml';  ?>
             </span>
        <?php endif; ?>
        <?php if (isset($this->price['unavailable']) && $this->price['unavailable']):  ?>
            <div class="asg_availability_unavailable">Currently unavailable</div>
        <?php endif;?>
    </div>
    <?php if (isset($this->alt)): ?>
        <div class="asg-alternative">
            <a class="asg-alternative-link"
                target="_blank"
                rel="nofollow"
                href="<?php echo $this->escape($this->alt['url']); ?>"
            >Also available on
                <?php echo $this->escape($marketInfo[$this->alt['market']]['domain']); ?></a>
            for
            <?php if (!isset($this->alt['offer'])): ?>
                <span class="asg_price_value"><?php echo $this->escape($this->alt['price']['listPrice']); ?></span>
            <?php else: ?>
                <span class="asg_price_list_value"><?php echo $this->escape($this->alt['price']['listPrice']); ?></span>
                <span class="asg_price_offer_value">
                    <?php if (isset($this->alt['price']['offer']['SalePrice']['FormattedPrice'])): ?>
                        <?php echo $this->escape($this->alt['price']['offer']['SalePrice']['FormattedPrice']); ?>
                    <?php else: ?>
                        <?php echo $this->escape($this->alt['price']['offer']['Price']['FormattedPrice']); ?>
                    <?php endif; ?>
                </span>
            <?php endif; ?>
            <span class="asg_price_notice">(as of <?php echo $this->escape($this->alt['updated']); ?> -
                <?php require 'includes/priceNotice.phtml';  ?>
            </span>
        </div>
    <?php endif; ?>
    <?php $this->getHelper('StripNewLines')->end(); ?>
<?php endif; ?>
<br /><br />
<?php echo $this->content; ?>
<?php if($this->single): ?>
    <?php if ($details = $this->meta->getValue('technical_details')) :?>
        <h2 class="asg_details_title">Technical Details</h2>
        <ul class="asg_details_list">
            <?php foreach ($details as $name => $value): ?>
                <li>
                    <?php if (is_string($name)): ?><strong><?php echo $this->escape($name);?>:</strong> <?php endif; ?>
                    <?php if (is_array($value)): ?>
                        <ul>
                            <?php foreach ($value as $valueItem): ?>
                                <li><?php echo $this->escape($valueItem);?></li>
                            <?php endforeach; ?>
                        </ul>
                    <?php else: ?>
                        <?php echo $this->escape($value);?>
                    <?php endif; ?>
                </li>
            <?php endforeach; ?>
        </ul>
    <?php endif; ?>
    <?php echo $this->partial('includes/shortcode.phtml', array('code' => 'ag-after-technical-details', 'content' => $this->shortcodes['ag-after-technical-details'])); ?>
    <?php if ($details = $this->meta->getValue('product_details')) :?>
        <h2 class="asg_details_title">Product Details</h2>
        <ul class="asg_details_list">
            <?php foreach ($details as $name => $value): ?>
                <li>
                    <?php if (is_string($name)): ?><strong><?php echo $this->escape($name);?>:</strong> <?php endif; ?>
                    <?php if (is_array($value)): ?>
                        <ul>
                            <?php foreach ($value as $valueItem): ?>
                                <li><?php echo $this->escape($valueItem);?></li>
                            <?php endforeach; ?>
                        </ul>
                    <?php else: ?>
                        <?php echo $this->escape($value);?>
                    <?php endif; ?>
                </li>
            <?php endforeach; ?>
        </ul>
    <?php endif; ?>
    <?php echo $this->partial('includes/shortcode.phtml', array('code' => 'ag-after-product-details', 'content' => $this->shortcodes['ag-after-product-details'])); ?>
    <?php if ('embed' == $this->options['show_reviews_rev2'] &&  $reviews = $this->meta->getValue('customer_reviews')): ?>
        <h2 class="asg_reviews_title">Customer Reviews</h2>
        <?php foreach ($reviews as $review): ?>
            <?php if (!is_null($review['star']) && $review['star'] >= $this->options['min_review_rating']): ?>
                <?php $this->getHelper('StripNewLines')->start(); ?>
                <?php if(isset($review['title'])):?>
                    <h3><?php echo $this->escape($review['title']);?></h3>
                <?php endif;?>
                <?php if(isset($review['helpful'])):?>
                    <div class="asg_review_helpful">
                        <span><?php echo $this->escape(str_replace('<br />', '', $review['helpful']));?></span>
                    </div>
                <?php endif;?>
                <div class="asg_star_rating-container">
                    <span class="asg_star_rating asg_star_rating-<?php echo $this->starRatingCode($review['star']); ?>"
                        title="<?php echo sprintf('%01.1f', $review['star']); ?> out of 5 stars">
                    </span>
                    <span>&nbsp;<?php echo $this->escape($review['date']);?></span>
                </div>
                <?php if (isset($review['author']) && '' != $review['author']): ?>
                    <?php $author = $review['author']; ?>
                    <div class="asg_review_author">
                        <span>By <?php echo $this->escape($author['name']);?></span>
                    </div>
                <?php endif;?>
                <div class="asg_review_text">
                    <?php echo $review['text'];?>
                </div>
                <?php $this->getHelper('StripNewLines')->end(); ?>
            <?php endif; ?>
        <?php endforeach; ?>
    <?php elseif ('iframe' == $this->options['show_reviews_rev2']
        && isset($this->amazon_data['CustomerReviews']['IFrameURL'])
        && isset($this->amazon_data['CustomerReviews']['HasReviews'])
        && $this->amazon_data['CustomerReviews']['HasReviews']
    ): ?>
        <iframe class="asg_reviews_iframe" src="<?php echo $this->amazon_data['CustomerReviews']['IFrameURL']; ?>"></iframe>
    <?php endif; ?>
    <?php echo $this->partial('includes/shortcode.phtml', array('code' => 'ag-after-reviews', 'content' => $this->shortcodes['ag-after-reviews'])); ?>
    <?php if ($this->eyeCandy->showBottom): ?>
        <?php require 'includes/candyBottom.phtml'; ?>
        <div class="asg_clearfix"></div>
    <?php endif; ?>
    <?php echo $this->partial('includes/shortcode.phtml', array('code' => 'ag-bottom', 'content' => $this->shortcodes['ag-bottom'])); ?>
<?php endif; ?>